/*****************************************************************************
 *
 * FILE:	rc4.h
 * DESCRIPTION:	RC4: Crypt library header file
 * DATE:	Thu, Jun 15 2006
 * UPDATED:	Mon, Jun 19 2006
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2006 졿Kouichi ABE (WALL), All rights reserved.
 * NOTES: 	cf. http://www.columbia.edu/~ariel/ssleay/rrc4.html
 * LICENSE:
 *
 *  Copyright (c) 2006 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 *   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *   SUCH DAMAGE.
 *
 * $Id: rc4.h,v 1.2 2007/09/02 19:11:24 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_RC4_H
#define	_RC4_H

/*****************************************************************************
 *
 *	Macros and structures definition
 *
 *****************************************************************************/
/* Numeric release version identifier: MNNFFPPS: major minor fix patch status */
#define LIBRC4_VERSION_NUMBER	0x10000010L
#define LIBRC4_VERSION		"librc4/1.0"
#define LIBRC4_VERSION_TEXT	LIBRC4_VERSION " (2006/06/19)"
#define	LIBRC4_URI		"http://www.MysticWALL.COM/"

#define	RC4_KEY_STATE_SIZE	(256)
typedef struct _rc4_key {
  unsigned char	state[RC4_KEY_STATE_SIZE];
  unsigned char	x;
  unsigned char	y;
} RC4_KEY;

/*****************************************************************************/
extern void	rc4_set_key(RC4_KEY * key,
			    const unsigned char * key_data_ptr,
			    size_t key_data_len);
extern void	rc4(RC4_KEY * key,
		    unsigned char * buffer_ptr, size_t buffer_len);

#endif	/* _RC4_H */
